Ebuild
March 30, 2014, 19:37
GIT - the stupid content tracker, the revision control system heavily used by the Linux kernel team
| alpha | amd64 | arm | hppa | ia64 | m68k | mips | ppc | ppc64 | s390 | sh | sparc | x86 | |
|---|---|---|---|---|---|---|---|---|---|---|---|---|---|
| 1.8.1.5-r1 | ~ | + | + | + | ~ | – | ~ | ~ | ~ | + | + | ~ | + |
CHANGELOG
# ChangeLog for dev-vcs/git # Copyright 1999-2014 Gentoo Foundation; Distributed under the GPL v2 # $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/ChangeLog,v 1.257 2014/04/09 23:59:31 robbat2 Exp $ *git-1.9.2 (10 Apr 2014) *git-1.8.4.4 (10 Apr 2014) 10 Apr 2014; Robin H. Johnson (robbat2) +git-1.8.4.4.ebuild, +git-1.9.2.ebuild: Bump. *git-1.9.1 (19 Mar 2014) 19 Mar 2014; Robin H. Johnson (robbat2) +git-1.9.1.ebuild: Bump. 09 Mar 2014; Pawel Hajdan jr (phajdan.jr) git-1.8.5.5.ebuild: x86 stable wrt bug #501662 03 Mar 2014; Lars Wendler (polynomial-c) -git-1.9.0_rc3.ebuild, files/git-daemon-r1.initd: Fixed pidfile location for non-linux systems. Removed old. 03 Mar 2014; Jason A. Donenfeld (zx2c4) files/git-daemon-r1.initd: Before this commit, clones would warn of "remote: warning: unable to access '/root/.config/git/attributes': Permission denied", because certain environment variables were passed to the daemon. This change removes such variables from the daemon's environment, squelching the error. 28 Feb 2014; Markus Meier (maekke) git-1.8.5.5.ebuild: arm stable, bug #501662 *git-9999-r3 (22 Feb 2014) *git-9999-r1 (22 Feb 2014) *git-9999-r2 (22 Feb 2014) 22 Feb 2014; Robin H. Johnson (robbat2) +git-9999-r1.ebuild, +git-9999-r2.ebuild, +git-9999-r3.ebuild, git-9999.ebuild: Make the upstream git development more accessible. The branches in order of stability: master,maint,next,pu are now 9999* ebuilds. 18 Feb 2014; Jeroen Roovers (jer) git-1.8.5.5.ebuild: Stable for HPPA (bug #501662). *git-1.9.0 (17 Feb 2014) 17 Feb 2014; Lars Wendler (polynomial-c) -git-1.8.5.3.ebuild, git-1.9.0_rc3.ebuild, +git-1.9.0.ebuild: Version bump. Removed old. *git-1.8.5.5 (13 Feb 2014) 13 Feb 2014; Robin H. Johnson (robbat2) +git-1.8.5.5.ebuild: Bump. 13 Feb 2014; Lars Wendler (polynomial-c) git-9999.ebuild: Minor fixes to live ebuild (bug #487902). *git-1.9.0_rc3 (08 Feb 2014) 08 Feb 2014; Robin H. Johnson (robbat2) +files/git-1.9.0_rc3-optional-cvs.patch, +git-1.9.0_rc3.ebuild: Bump. 07 Feb 2014; Lars Wendler (polynomial-c) git-1.8.1.5.ebuild, git-1.8.1.5-r1.ebuild, git-1.8.2.1.ebuild, git-1.8.3.2-r1.ebuild, git-1.8.4.5.ebuild, git-1.8.5.3.ebuild, git-1.8.5.4.ebuild, git-9999.ebuild, files/git-daemon-r1.initd: Attempt to fix startup of git-daemon as non-root user (bug #460370). Added sys-devel/gettext to DEPEND when nls USE flag is enabled. *git-1.8.5.4 (06 Feb 2014) 06 Feb 2014; Lars Wendler (polynomial-c) +git-1.8.5.4.ebuild: Version bump. 04 Feb 2014; Lars Wendler (polynomial-c) git-1.8.1.5.ebuild, git-1.8.1.5-r1.ebuild, git-1.8.2.1.ebuild, git-1.8.4.5.ebuild, -git-1.8.5.2.ebuild, git-1.8.5.3.ebuild, git-9999.ebuild, -files/git-1.7.12-git-svn-backport.patch, +files/git-daemon-r1.initd: Added rewritten init script which no longer contains "need net" (bug #490446). Added epatch_user (bug #497292). Added www-servers/nginx to the list of server who work with git-instaweb (bug #491862). Removed reference to no longer needed patch in remaining ebuilds. Removed old files and ebuilds. Don't install git-prompt.sh as bash-completion file (bug #477920). 18 Jan 2014; Mike Frysinger (vapier) git-1.8.1.5-r1.ebuild, git-1.8.3.2-r1.ebuild: Mark s390/sh stable. 17 Jan 2014; Matthew Thode (prometheanfire) metadata.xml: removing myself as maintainer of git *git-1.8.5.3 (14 Jan 2014) 14 Jan 2014; Lars Wendler (polynomial-c) -git-1.8.5.1.ebuild, +git-1.8.5.3.ebuild: Version bump. Removed old. 04 Jan 2014; Andreas K. Huettel (dilfridge) git-1.8.5.2.ebuild, git-9999.ebuild: Add missing git-mw runtime dependency 04 Jan 2014; Andreas K. Huettel (dilfridge) git-1.8.5.2.ebuild, +files/git-1.8.5-mw-destdir.patch, +files/git-1.8.5-mw-vendor.patch, git-9999.ebuild, metadata.xml: Add (masked until dependencies are keyworded) support for mediawiki, use subslot dependency on perl *git-1.8.5.2 (18 Dec 2013) 18 Dec 2013; Lars Wendler (polynomial-c) +git-1.8.5.2.ebuild: Version bump. 11 Dec 2013; Sergey Popov (pinkbyte) git-1.8.3.2-r1.ebuild: Stable on arm, wrt bug #480306 11 Dec 2013; Lars Wendler (polynomial-c) git-1.8.1.5.ebuild, git-1.8.1.5-r1.ebuild, git-1.8.2.1.ebuild, git-1.8.3.2-r1.ebuild, git-1.8.4.5.ebuild, git-1.8.5.1.ebuild, git-9999.ebuild: Added t9402-git-cvsserver-refs.sh and t9604-cvsimport-timestamps.sh to the cvs-only tests (bug #492556). 09 Dec 2013; Mikle Kolyada (zlogene) git-1.8.3.2-r1.ebuild: ia64 stable wrt bug #480306 07 Dec 2013; Johannes Huber (johu) git-1.8.3.2-r1.ebuild: x86 stable, bug #480306 06 Dec 2013; Lars Wendler (polynomial-c) git-1.8.1.5.ebuild, git-1.8.1.5-r1.ebuild, git-1.8.2.1.ebuild, -git-1.8.3.2.ebuild, -git-1.8.4.ebuild, -git-1.8.4.2.ebuild, -git-1.8.4.3.ebuild, -git-1.8.4.4.ebuild: Fixed remaining ebuilds who suffer from bug #485166. Removed some older versions. 05 Dec 2013; Lars Wendler (polynomial-c) git-9999.ebuild: Added changes to live ebuild. *git-1.8.5.1 (05 Dec 2013) 05 Dec 2013; Lars Wendler (polynomial-c) -git-1.6.4.5.ebuild, -git-1.7.2.5.ebuild, -git-1.7.3.4-r1.ebuild, -git-1.7.8.6.ebuild, -git-1.7.12.4.ebuild, -git-1.8.0.2.ebuild, +git-1.8.5.1.ebuild, -files/git-1.6.6.1-interix6.patch, -files/git-1.7.1-interix.patch, -files/git-1.7.2-always-install-js.patch, -files/git-1.7.3.2-interix.patch, -files/git-1.7.3.4-avoid-shell-issues.patch, -files/git-1.7.3.4-fix-perl-test-prereq.patch, -files/git-1.7.3.5-optional-cvs.patch, -files/git-1.7.11-optional-cvs.patch, +files/git-1.8.5-optional-cvs.patch, metadata.xml: Version bump. Removed old. *git-1.8.4.5 (04 Dec 2013) 04 Dec 2013; Lars Wendler (polynomial-c) +git-1.8.4.5.ebuild: Version bump (bug #493348). *git-1.8.4.4 (21 Nov 2013) 21 Nov 2013; Robin H. Johnson (robbat2) +git-1.8.4.4.ebuild: Bump. 09 Nov 2013; Pacho Ramos (pacho) git-1.8.3.2-r1.ebuild: amd64 stable, bug #480306 *git-1.8.4.3 (09 Nov 2013) 09 Nov 2013; Robin H. Johnson (robbat2) +git-1.8.4.3.ebuild: Bump. 06 Nov 2013; Patrick Lauer (patrick) git-1.8.3.2-r1.ebuild: Un-stabling for amd64 as dependencies are not ready 05 Nov 2013; Mikle Kolyada (zlogene) git-1.8.3.2-r1.ebuild: amd64 stable wrt bug #480306 03 Nov 2013; Matt Turner (mattst88) git-1.8.3.2-r1.ebuild: alpha stable, bug 480306. 03 Nov 2013; Matthew Thode (prometheanfire) metadata.xml: just adding myself to the list of maintianers 01 Nov 2013; Lars Wendler (polynomial-c) metadata.xml: Added myself as maintainer. *git-1.8.4.2 (28 Oct 2013) 28 Oct 2013; Robin H. Johnson (robbat2) +git-1.8.4.2.ebuild: Bump. 20 Oct 2013; Fabian Groffen (grobian) git-1.8.4.ebuild, git-9999.ebuild: Fix sed expression not to be too greedy, bug #488440 17 Oct 2013; Jeroen Roovers (jer) git-1.8.3.2-r1.ebuild: Stable for HPPA (bug #480306). *git-1.8.3.2-r1 (15 Oct 2013) 15 Oct 2013; Robin H. Johnson (robbat2) +git-1.8.3.2-r1.ebuild: Backport fixes for bug #477096: Fix git-remote-bzr file collision & bug #479628: Fix pthread usage to 1.8.3. *git-1.8.4 (15 Oct 2013) 15 Oct 2013; Robin H. Johnson (robbat2) +files/git-1.8.4-optional-cvs.patch, +git-1.8.4.ebuild, git-9999.ebuild: Bug #485844: Bump. Bug #477096: Fix git-remote-bzr file collision. Bug #479628: Fix pthread usage. 15 Oct 2013; Mikle Kolyada (zlogene) git-1.8.1.5-r1.ebuild: x86 stable wrt bug #480054 14 Oct 2013; Tony Vroon (chainsaw) git-1.8.1.5-r1.ebuild: Marked stable on AMD64 based on arch tester report by Elijah "Armageddon" El Lazkani in bug #480054. 07 Oct 2013; William Hubbs (williamh) git-9999.ebuild: sync live ebuild 07 Oct 2013; Rick Farina (zerochaos) git-1.8.3.2.ebuild: changing dep to make error message more useful because earlier version of dev- python/pygtksourceview:2 have no [] 06 Oct 2013; Jeroen Roovers (jer) git-1.8.1.5-r1.ebuild: Stable for HPPA (bug #480054). 06 Oct 2013; Markus Meier (maekke) git-1.8.1.5-r1.ebuild: arm stable, bug #480054 *git-1.8.1.5-r1 (28 Sep 2013) 28 Sep 2013; Pacho Ramos (pacho) +git-1.8.1.5-r1.ebuild: Backport unit files to allow faster stabilization 16 Sep 2013; Michał Górny (mgorny) git-1.8.3.2.ebuild, git-9999.ebuild: Use ${PYTHON} rather than $(python_get_PYTHON). It is exported anyway. 31 Jul 2013; Matt Turner (mattst88) git-1.8.3.2.ebuild, git-9999.ebuild: Allow building against >=dev-lang/perl-5.16 without 'build' in IUSE. 26 Jul 2013; William Hubbs (williamh) git-9999.ebuild: non-maintainer commit: sync live ebuild with git-1.8.3.2. 15 Jul 2013; Jonathan Callen (abcd) git-1.8.3.2.ebuild: Non-maintainer update: make ${PYTHON_REQUIRED_USE} conditional on USE=python; fix pygtk and pygtksourceview deps to require that they be built with the same version of python as this package; replace built_with_use calls with has_version; remove python 2.5 support as none of the dependencies support it. 11 Jul 2013; Lars Wendler (polynomial-c) git-1.8.3.2.ebuild: Non-maintainer commit: Fixed test failure when built with USE="-perl" (bug #476472). Also fixed wrong located python_optimize call. Thanks to Arfrever for pointing this out in IRC and mgorny for giving advice how to fix this. *git-1.8.3.2 (09 Jul 2013) 09 Jul 2013; Lars Wendler (polynomial-c) +git-1.8.3.2.ebuild: Non-maintainer commit: Version bump (bug #467856). Converted ebuild to EAPI-5 and python-single-r1 eclass. Added gtk -> python REQUIRED_USE (bug #451374). Hopefully fixed test failure with USE=-perl (bug #470592). Added installation of git-remote-hg (bug #465808) and git-remote-bzr with USE=python. 18 May 2013; Fabio Erculiani (lxnay) git-1.8.2.1.ebuild, git-9999.ebuild, +files/git-daemon.socket, +files/git-daemon_at.service: add systemd unit supporting socket activation to 1.8.21 and 9999, fix bug #468846 19 Apr 2013; Mike Frysinger (vapier) git-1.8.2.1.ebuild: Add missing pthreads linkage for svn-fe #466178 by Mike Gilbert. 17 Apr 2013; Robin H. Johnson (robbat2) git-1.8.2.1.ebuild: Bug #466178: better use of variables to make svn-fe always compile right. *git-1.8.2.1 (16 Apr 2013) 16 Apr 2013; Robin H. Johnson (robbat2) +files/git-1.8.2-optional-cvs.patch, +files/git-1.8.2-texinfo.patch, +git-1.8.2.1.ebuild: Verbump. Bug #464210: fix texinfo 5.1 @anchor handling. 19 Mar 2013; Agostino Sarubbo (ago) -git-1.7.12-r1.ebuild, -git-1.7.12-r2.ebuild, -git-1.7.12.3-r1.ebuild, -git-1.7.12.3.ebuild, -git-1.7.12.ebuild, -git-1.8.0-r1.ebuild, -git-1.8.0.ebuild, -git-1.8.1.1.ebuild, -git-1.8.1.2.ebuild, -git-1.8.1.4.ebuild, -git-1.8.1.ebuild: Remove old 10 Mar 2013; Agostino Sarubbo (ago) git-1.8.1.5.ebuild: Stable for s390, wrt bug #459158 09 Mar 2013; Agostino Sarubbo (ago) git-1.8.1.5.ebuild: Stable for sparc, wrt bug #459158 09 Mar 2013; Agostino Sarubbo (ago) git-1.8.1.5.ebuild: Stable for ia64, wrt bug #459158 09 Mar 2013; Agostino Sarubbo (ago) git-1.8.1.5.ebuild: Stable for alpha, wrt bug #459158 09 Mar 2013; Agostino Sarubbo (ago) git-1.8.1.5.ebuild: Stable for ppc64, wrt bug #459158 08 Mar 2013; Agostino Sarubbo (ago) git-1.8.1.5.ebuild: Stable for arm, wrt bug #459158 06 Mar 2013; Agostino Sarubbo (ago) git-1.8.1.5.ebuild: Stable for sh, wrt bug #459158 05 Mar 2013; Jeroen Roovers (jer) git-1.8.1.5.ebuild: Stable for HPPA (bug #459158). 04 Mar 2013; Brent Baude (ranger) git-1.8.1.5.ebuild: Marking git-1.8.1.5 ppc for bug 459158 04 Mar 2013; Agostino Sarubbo (ago) git-1.8.1.5.ebuild: Stable for x86, wrt bug #459158 04 Mar 2013; Agostino Sarubbo (ago) git-1.8.1.5.ebuild: Stable for amd64, wrt bug #459158 *git-1.8.1.5 (01 Mar 2013) 01 Mar 2013; Robin H. Johnson (robbat2) +git-1.8.1.5.ebuild: Bump. 24 Feb 2013; Agostino Sarubbo (ago) git-1.7.12.4.ebuild: Stable for sh, wrt bug #436704 22 Feb 2013; Zac Medico (zmedico) git-1.8.1.2.ebuild, git-1.8.1.4.ebuild, git-9999.ebuild: Add ~arm-linux keywords. *git-1.8.1.4 (20 Feb 2013) 20 Feb 2013; Robin H. Johnson (robbat2) +git-1.8.1.4.ebuild: Bump. 20 Feb 2013; Agostino Sarubbo (ago) git-1.7.12.4.ebuild: Stable for s390, wrt bug #436704 29 Jan 2013; Fabian Groffen (grobian) git-1.8.0.2.ebuild, git-1.8.1.2.ebuild: Do not install git daemon init.d script on Prefix *git-1.8.1.2 (28 Jan 2013) 28 Jan 2013; Robin H. Johnson (robbat2) +git-1.8.1.2.ebuild: Autobump. 21 Jan 2013; Agostino Sarubbo (ago) git-1.7.12.4.ebuild: Stable for sparc, wrt bug #436704 21 Jan 2013; Agostino Sarubbo (ago) git-1.7.12.4.ebuild: Stable for ia64, wrt bug #436704 20 Jan 2013; Agostino Sarubbo (ago) git-1.7.12.4.ebuild: Stable for alpha, wrt bug #436704 16 Jan 2013; Agostino Sarubbo (ago) git-1.7.12.4.ebuild: Stable for ppc64, wrt bug #436704 16 Jan 2013; Agostino Sarubbo (ago) git-1.7.12.4.ebuild: Stable for ppc, wrt bug #436704 15 Jan 2013; Markus Meier (maekke) git-1.7.12.4.ebuild: arm stable, bug #436704 *git-1.8.1.1 (15 Jan 2013) 15 Jan 2013; Robin H. Johnson (robbat2) +git-1.8.1.1.ebuild: Bump. 15 Jan 2013; Jeroen Roovers (jer) git-1.7.12.4.ebuild: Stable for HPPA (bug #436704). 10 Jan 2013; Agostino Sarubbo (ago) git-1.7.12.4.ebuild: Stable for x86, wrt bug #436704 10 Jan 2013; Agostino Sarubbo (ago) git-1.7.12.4.ebuild: Stable for amd64, wrt bug #436704 *git-1.8.1 (03 Jan 2013) 03 Jan 2013; Robin H. Johnson (robbat2) +git-1.8.1.ebuild: Bump. 01 Jan 2013; Andreas K. Huettel (dilfridge) +ChangeLog-2012: Split ChangeLog. For previous entries, please see ChangeLog-2012.
USE FLAGS
| blksha1 | Use the new optimized SHA1 implementation |
| cgi | Install gitweb too |
| curl | Support fetching and pushing (requires webdav too) over http:// and https:// protocols |
| cvs | Enable CVS (Concurrent Versions System) integration |
| doc | Add extra documentation (API, Javadoc, etc). It is recommended to enable per package instead of globally |
| emacs | Add support for GNU Emacs |
| gnome-keyring | Enable support for storing passwords via gnome-keyring |
| gpg | Pull in gnupg for signing -- without gnupg, attempts at signing will fail at runtime! |
| gtk | Include the gitview contrib tool |
| highlight | GitWeb support for app-text/highlight |
| iconv | Enable support for the iconv character set conversion library |
| nls | Add Native Language Support (using gettext - GNU locale utilities) |
| pcre | Add support for Perl Compatible Regular Expressions |
| perl | Add optional support/bindings for the Perl language |
| ppcsha1 | Make use of a bundled routine that is optimized for the PPC arch |
| python | Add optional support/bindings for the Python language |
| subversion | Include git-svn for dev-vcs/subversion support |
| test | Workaround to pull in packages needed to run with FEATURES=test. Portage-2.1.2 handles this internally, so don't set it in make.conf/package.use anymore |
| threads | Add threads support for various packages. Usually pthreads |
| tk | Add support for Tk GUI toolkit |
| webdav | Adds support for push'ing to HTTP/HTTPS repositories via DAV |
| xinetd | Add support for the xinetd super-server |
SOURCE CODE
# Copyright 1999-2014 Gentoo Foundation
# Distributed under the terms of the GNU General Public License v2
# $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/git-1.8.1.5-r1.ebuild,v 1.10
2014/02/07 07:59:03 polynomial-c Exp $
EAPI=4
GENTOO_DEPEND_ON_PERL=no
# bug #329479: git-remote-testgit is not multiple-version aware
PYTHON_DEPEND="python? 2"
[[ ${PV} == *9999 ]] && SCM="git-2"
EGIT_REPO_URI="git://git.kernel.org/pub/scm/git/git.git"
inherit toolchain-funcs eutils elisp-common perl-module bash-completion-r1
python systemd ${SCM}
MY_PV="${PV/_rc/.rc}"
MY_P="${PN}-${MY_PV}"
DOC_VER=${MY_PV}
DESCRIPTION="GIT - the stupid content tracker, the revision control system
heavily used by the Linux kernel team"
HOMEPAGE="http://www.git-scm.com/"
if [[ ${PV} != *9999 ]]; then
SRC_URI_SUFFIX="gz"
SRC_URI_GOOG="http://git-core.googlecode.com/files"
SRC_URI_KORG="mirror://kernel/software/scm/git"
SRC_URI="${SRC_URI_GOOG}/${MY_P}.tar.${SRC_URI_SUFFIX}
${SRC_URI_KORG}/${MY_P}.tar.${SRC_URI_SUFFIX}
${SRC_URI_GOOG}/${PN}-manpages-${DOC_VER}.tar.${SRC_URI_SUFFIX}
${SRC_URI_KORG}/${PN}-manpages-${DOC_VER}.tar.${SRC_URI_SUFFIX}
doc? (
${SRC_URI_KORG}/${PN}-htmldocs-${DOC_VER}.tar.${SRC_URI_SUFFIX}
${SRC_URI_GOOG}/${PN}-htmldocs-${DOC_VER}.tar.${SRC_URI_SUFFIX}
)"
KEYWORDS="~alpha amd64 arm hppa ~ia64 ~mips ~ppc ~ppc64 s390 sh ~sparc x86
~ppc-aix ~amd64-fbsd ~sparc-fbsd ~x86-fbsd ~x64-freebsd ~x86-freebsd ~ia64-hpux
~x86-interix ~amd64-linux ~arm-linux ~ia64-linux ~x86-linux ~ppc-macos
~x64-macos ~x86-macos ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
else
SRC_URI=""
KEYWORDS=""
fi
LICENSE="GPL-2"
SLOT="0"
IUSE="+blksha1 +curl cgi doc emacs gnome-keyring +gpg gtk highlight +iconv +nls
+pcre +perl +python ppcsha1 tk +threads +webdav xinetd cvs subversion test"
# Common to both DEPEND and RDEPEND
CDEPEND="
dev-libs/openssl
sys-libs/zlib
pcre? ( dev-libs/libpcre )
perl? ( dev-lang/perl[-build(-)] )
tk? ( dev-lang/tk )
curl? (
net-misc/curl
webdav? ( dev-libs/expat )
)
emacs? ( virtual/emacs )
gnome-keyring? ( gnome-base/gnome-keyring )"
RDEPEND="${CDEPEND}
gpg? ( app-crypt/gnupg )
perl? ( dev-perl/Error
dev-perl/Net-SMTP-SSL
dev-perl/Authen-SASL
cgi? ( virtual/perl-CGI highlight? ( app-text/highlight ) )
cvs? ( >=dev-vcs/cvsps-2.1 dev-perl/DBI dev-perl/DBD-SQLite )
subversion? ( dev-vcs/subversion[-dso,perl] dev-perl/libwww-perl
dev-perl/TermReadKey )
)
python? ( gtk?
(
>=dev-python/pygtk-2.8
dev-python/pygtksourceview:2
) )"
# This is how info docs are created with Git:
# .txt/asciidoc --(asciidoc)---------> .xml/docbook
# .xml/docbook --(docbook2texi.pl)--> .texi
# .texi --(makeinfo)---------> .info
DEPEND="${CDEPEND}
app-arch/cpio
doc? (
app-text/asciidoc
app-text/docbook2X
sys-apps/texinfo
app-text/xmlto
)
nls? ( sys-devel/gettext )
test? ( app-crypt/gnupg )"
# Live ebuild builds man pages and HTML docs, additionally
if [[ ${PV} == *9999 ]]; then
DEPEND="${DEPEND}
app-text/asciidoc"
fi
SITEFILE=50${PN}-gentoo.el
S="${WORKDIR}/${MY_P}"
REQUIRED_USE="
cgi? ( perl )
cvs? ( perl )
subversion? ( perl )
webdav? ( curl )
"
pkg_setup() {
if use subversion && has_version dev-vcs/subversion && built_with_use --missing
false dev-vcs/subversion dso ; then
ewarn "Per Gentoo bugs #223747, #238586, when subversion is built"
ewarn "with USE=dso, there may be weird crashes in git-svn. You"
ewarn "have been warned."
fi
if use python ; then
python_set_active_version 2
python_pkg_setup
fi
}
# This is needed because for some obscure reasons future calls to make don't
# pick up these exports if we export them in src_unpack()
exportmakeopts() {
local myopts
if use blksha1 ; then
myopts="${myopts} BLK_SHA1=YesPlease"
elif use ppcsha1 ; then
myopts="${myopts} PPC_SHA1=YesPlease"
fi
if use curl ; then
use webdav || myopts="${myopts} NO_EXPAT=YesPlease"
else
myopts="${myopts} NO_CURL=YesPlease"
fi
# broken assumptions, because of broken build system ...
myopts="${myopts} NO_FINK=YesPlease NO_DARWIN_PORTS=YesPlease"
myopts="${myopts} INSTALL=install TAR=tar"
myopts="${myopts} SHELL_PATH=${EPREFIX}/bin/sh"
myopts="${myopts} SANE_TOOL_PATH="
myopts="${myopts} OLD_ICONV="
myopts="${myopts} NO_EXTERNAL_GREP="
# can't define this to null, since the entire makefile depends on it
sed -i -e '/\/usr\/local/s/BASIC_/#BASIC_/' Makefile
use iconv \
|| myopts="${myopts} NO_ICONV=YesPlease"
use nls \
|| myopts="${myopts} NO_GETTEXT=YesPlease"
use tk \
|| myopts="${myopts} NO_TCLTK=YesPlease"
use pcre \
&& myopts="${myopts} USE_LIBPCRE=yes"
use perl \
&& myopts="${myopts} INSTALLDIRS=vendor" \
|| myopts="${myopts} NO_PERL=YesPlease"
use python \
|| myopts="${myopts} NO_PYTHON=YesPlease"
use subversion \
|| myopts="${myopts} NO_SVN_TESTS=YesPlease"
use threads \
&& myopts="${myopts} THREADED_DELTA_SEARCH=YesPlease"
use cvs \
|| myopts="${myopts} NO_CVS=YesPlease"
# Disabled until ~m68k-mint can be keyworded again
# if [[ ${CHOST} == *-mint* ]] ; then
# myopts="${myopts} NO_MMAP=YesPlease"
# myopts="${myopts} NO_IPV6=YesPlease"
# myopts="${myopts} NO_STRLCPY=YesPlease"
# myopts="${myopts} NO_MEMMEM=YesPlease"
# myopts="${myopts} NO_MKDTEMP=YesPlease"
# myopts="${myopts} NO_MKSTEMPS=YesPlease"
# fi
if [[ ${CHOST} == ia64-*-hpux* ]]; then
myopts="${myopts} NO_NSEC=YesPlease"
fi
if [[ ${CHOST} == *-*-aix* ]]; then
myopts="${myopts} NO_FNMATCH_CASEFOLD=YesPlease"
fi
if [[ ${CHOST} == *-solaris* ]]; then
myopts="${myopts} NEEDS_LIBICONV=YesPlease"
fi
has_version '>=app-text/asciidoc-8.0' \
&& myopts="${myopts} ASCIIDOC8=YesPlease"
myopts="${myopts} ASCIIDOC_NO_ROFF=YesPlease"
# Bug 290465:
# builtin-fetch-pack.c:816: error: 'struct stat' has no member named 'st_mtim'
[[ "${CHOST}" == *-uclibc* ]] && \
myopts="${myopts} NO_NSEC=YesPlease"
export MY_MAKEOPTS="${myopts}"
}
src_unpack() {
if [[ ${PV} != *9999 ]]; then
unpack ${MY_P}.tar.${SRC_URI_SUFFIX}
cd "${S}"
unpack ${PN}-manpages-${DOC_VER}.tar.${SRC_URI_SUFFIX}
use doc && \
cd "${S}"/Documentation && \
unpack ${PN}-htmldocs-${DOC_VER}.tar.${SRC_URI_SUFFIX}
cd "${S}"
else
git-2_src_unpack
cd "${S}"
#cp "${FILESDIR}"/GIT-VERSION-GEN .
fi
}
src_prepare() {
# bug #350330 - automagic CVS when we don't want it is bad.
epatch "${FILESDIR}"/git-1.7.12-optional-cvs.patch
sed -i \
-e 's:^\(CFLAGS =\).*$:\1 $(OPTCFLAGS) -Wall:' \
-e 's:^\(LDFLAGS =\).*$:\1 $(OPTLDFLAGS):' \
-e 's:^\(CC = \).*$:\1$(OPTCC):' \
-e 's:^\(AR = \).*$:\1$(OPTAR):' \
-e "s:\(PYTHON_PATH = \)\(.*\)$:\1${EPREFIX}\2:" \
-e "s:\(PERL_PATH = \)\(.*\)$:\1${EPREFIX}\2:" \
Makefile || die "sed failed"
# Never install the private copy of Error.pm (bug #296310)
sed -i \
-e '/private-Error.pm/s,^,#,' \
perl/Makefile.PL
# Fix docbook2texi command
sed -i 's/DOCBOOK2X_TEXI=docbook2x-texi/DOCBOOK2X_TEXI=docbook2texi.pl/' \
Documentation/Makefile || die "sed failed"
# Fix git-subtree missing DESTDIR
sed -i \
-e '/$(INSTALL)/s/ $(libexecdir)/ $(DESTDIR)$(libexecdir)/g' \
-e '/$(INSTALL)/s/ $(man1dir)/ $(DESTDIR)$(man1dir)/g' \
contrib/subtree/Makefile
}
git_emake() {
# bug #326625: PERL_PATH, PERL_MM_OPT
# bug #320647: PYTHON_PATH
PYTHON_PATH=""
use python && PYTHON_PATH="$(PYTHON -a)"
emake ${MY_MAKEOPTS} \
DESTDIR="${D}" \
OPTCFLAGS="${CFLAGS}" \
OPTLDFLAGS="${LDFLAGS}" \
OPTCC="$(tc-getCC)" \
OPTAR="$(tc-getAR)" \
prefix="${EPREFIX}"/usr \
htmldir="${EPREFIX}"/usr/share/doc/${PF}/html \
sysconfdir="${EPREFIX}"/etc \
PYTHON_PATH="${PYTHON_PATH}" \
PERL_MM_OPT="" \
GIT_TEST_OPTS="--no-color" \
"$@"
# This is the fix for bug #326625, but it also causes breakage, see bug
# #352693.
# PERL_PATH="${EPREFIX}/usr/bin/env perl" \
}
src_configure() {
exportmakeopts
}
src_compile() {
if use perl ; then
git_emake perl/PM.stamp || die "emake perl/PM.stamp failed"
git_emake perl/perl.mak || die "emake perl/perl.mak failed"
fi
git_emake || die "emake failed"
if use emacs ; then
elisp-compile contrib/emacs/git{,-blame}.el \
|| die "emacs modules failed"
fi
if use perl && use cgi ; then
git_emake \
gitweb/gitweb.cgi \
|| die "emake gitweb/gitweb.cgi failed"
fi
if [[ ${CHOST} == *-darwin* ]]; then
cd "${S}"/contrib/credential/osxkeychain || die "cd credential/osxkeychain"
git_emake || die "emake credential-osxkeychain"
fi
cd "${S}"/Documentation
if [[ ${PV} == *9999 ]] ; then
git_emake man \
|| die "emake man failed"
if use doc ; then
git_emake info html \
|| die "emake info html failed"
fi
else
if use doc ; then
git_emake info \
|| die "emake info html failed"
fi
fi
if use subversion ; then
cd "${S}"/contrib/svn-fe
git_emake || die "emake svn-fe failed"
if use doc ; then
git_emake svn-fe.{1,html} || die "emake svn-fe.1 svn-fe.html failed"
fi
cd "${S}"
fi
if use gnome-keyring ; then
cd "${S}"/contrib/credential/gnome-keyring
git_emake || die "emake git-credential-gnome-keyring failed"
fi
cd "${S}"/contrib/subtree
git_emake
use doc && git_emake doc
}
src_install() {
git_emake \
install || \
die "make install failed"
if [[ ${CHOST} == *-darwin* ]]; then
dobin contrib/credential/osxkeychain/git-credential-osxkeychain
fi
# Depending on the tarball and manual rebuild of the documentation, the
# manpages may exist in either OR both of these directories.
find man?/*.[157] >/dev/null 2>&1 && doman man?/*.[157]
find Documentation/*.[157] >/dev/null 2>&1 && doman Documentation/*.[157]
dodoc README Documentation/{SubmittingPatches,CodingGuidelines}
use doc && dodir /usr/share/doc/${PF}/html
for d in / /howto/ /technical/ ; do
docinto ${d}
dodoc Documentation${d}*.txt
use doc && dohtml -p ${d} Documentation${d}*.html
done
docinto /
# Upstream does not ship this pre-built :-(
use doc && doinfo Documentation/{git,gitman}.info
newbashcomp contrib/completion/git-completion.bash ${PN}
newbashcomp contrib/completion/git-prompt.sh ${PN}-prompt
if use emacs ; then
elisp-install ${PN} contrib/emacs/git.{el,elc} || die
elisp-install ${PN} contrib/emacs/git-blame.{el,elc} || die
#elisp-install ${PN}/compat contrib/emacs/vc-git.{el,elc} || die
# don't add automatically to the load-path, so the sitefile
# can do a conditional loading
touch "${ED}${SITELISP}/${PN}/compat/.nosearch"
elisp-site-file-install "${FILESDIR}"/${SITEFILE} || die
fi
if use python && use gtk ; then
dobin "${S}"/contrib/gitview/gitview
python_convert_shebangs ${PYTHON_ABI} "${ED}"/usr/bin/gitview
dodoc "${S}"/contrib/gitview/gitview.txt
fi
#dobin contrib/fast-import/git-p4 # Moved upstream
#dodoc contrib/fast-import/git-p4.txt # Moved upstream
newbin contrib/fast-import/import-tars.perl import-tars
newbin contrib/git-resurrect.sh git-resurrect
# git-subtree
cd "${S}"/contrib/subtree
git_emake install || die "Failed to emake install git-subtree"
if use doc ; then
git_emake install-man install-doc || die "Failed to emake install-doc
install-mangit-subtree"
fi
newdoc README README.git-subtree
dodoc git-subtree.txt
cd "${S}"
# git-diffall
dobin contrib/diffall/git-diffall
newdoc contrib/diffall/README git-diffall.txt
# diff-highlight
dobin contrib/diff-highlight/diff-highlight
newdoc contrib/diff-highlight/README README.diff-highlight
# git-jump
dobin contrib/git-jump/git-jump
newdoc contrib/git-jump/README git-jump.txt
if use gnome-keyring ; then
cd "${S}"/contrib/credential/gnome-keyring
dobin git-credential-gnome-keyring
fi
if use subversion ; then
cd "${S}"/contrib/svn-fe
dobin svn-fe
dodoc svn-fe.txt
use doc && doman svn-fe.1 && dohtml svn-fe.html
cd "${S}"
fi
dodir /usr/share/${PN}/contrib
# The following are excluded:
# completion - installed above
# credential/gnome-keyring TODO
# diff-highlight - done above
# diffall - done above
# emacs - installed above
# examples - these are stuff that is not used in Git anymore actually
# git-jump - done above
# gitview - installed above
# p4import - excluded because fast-import has a better one
# patches - stuff the Git guys made to go upstream to other places
# persistent-https - TODO
# mw-to-git - TODO
# subtree - build seperately
# svnimport - use git-svn
# thunderbird-patch-inline - fixes thunderbird
for i in \
blameview buildsystems ciabot continuous convert-objects fast-import \
hg-to-git hooks remotes2config.sh rerere-train.sh \
stats vim workdir \
; do
cp -rf \
"${S}"/contrib/${i} \
"${ED}"/usr/share/${PN}/contrib \
|| die "Failed contrib ${i}"
done
if use perl && use cgi ; then
# We used to install in /usr/share/${PN}/gitweb
# but upstream installs in /usr/share/gitweb
# so we will install a symlink and use their location for compat with other
# distros
dosym /usr/share/gitweb /usr/share/${PN}/gitweb
# INSTALL discusses configuration issues, not just installation
docinto /
newdoc "${S}"/gitweb/INSTALL INSTALL.gitweb
newdoc "${S}"/gitweb/README README.gitweb
find "${ED}"/usr/lib64/perl5/ \
-name .packlist \
-exec rm \{\} \;
else
rm -rf "${ED}"/usr/share/gitweb
fi
if ! use subversion ; then
rm -f "${ED}"/usr/libexec/git-core/git-svn \
"${ED}"/usr/share/man/man1/git-svn.1*
fi
if use xinetd ; then
insinto /etc/xinetd.d
newins "${FILESDIR}"/git-daemon.xinetd git-daemon
fi
if use !prefix ; then
newinitd "${FILESDIR}"/git-daemon.initd git-daemon
newconfd "${FILESDIR}"/git-daemon.confd git-daemon
systemd_newunit "${FILESDIR}/git-daemon_at.service" "git-daemon@.service"
systemd_dounit "${FILESDIR}/git-daemon.socket"
fi
fixlocalpod
}
src_test() {
local disabled=""
local tests_cvs="t9200-git-cvsexportcommit.sh \
t9400-git-cvsserver-server.sh \
t9401-git-cvsserver-crlf.sh \
t9600-cvsimport.sh \
t9601-cvsimport-vendor-branch.sh \
t9602-cvsimport-branches-tags.sh \
t9603-cvsimport-patchsets.sh \
t9604-cvsimport-timestamps.sh"
local tests_perl="t5502-quickfetch.sh \
t5512-ls-remote.sh \
t5520-pull.sh"
# Bug #225601 - t0004 is not suitable for root perm
# Bug #219839 - t1004 is not suitable for root perm
# t0001-init.sh - check for init notices EPERM* fails
local tests_nonroot="t0001-init.sh \
t0004-unwritable.sh \
t0070-fundamental.sh \
t1004-read-tree-m-u-wf.sh \
t3700-add.sh \
t7300-clean.sh"
# t9100 still fails with symlinks in SVN 1.7
local test_svn="t9100-git-svn-basic.sh"
# Unzip is used only for the testcase code, not by any normal parts of Git.
if ! has_version app-arch/unzip ; then
einfo "Disabling tar-tree tests"
disabled="${disabled} t5000-tar-tree.sh"
fi
cvs=0
use cvs && let cvs=$cvs+1
if [[ ${EUID} -eq 0 ]]; then
if [[ $cvs -eq 1 ]]; then
ewarn "Skipping CVS tests because CVS does not work as root!"
ewarn "You should retest with FEATURES=userpriv!"
disabled="${disabled} ${tests_cvs}"
fi
einfo "Skipping other tests that require being non-root"
disabled="${disabled} ${tests_nonroot}"
else
[[ $cvs -gt 0 ]] && \
has_version dev-vcs/cvs && \
let cvs=$cvs+1
[[ $cvs -gt 1 ]] && \
built_with_use dev-vcs/cvs server && \
let cvs=$cvs+1
if [[ $cvs -lt 3 ]]; then
einfo "Disabling CVS tests (needs dev-vcs/cvs[USE=server])"
disabled="${disabled} ${tests_cvs}"
fi
fi
if ! use perl ; then
einfo "Disabling tests that need Perl"
disabled="${disabled} ${tests_perl}"
fi
einfo "Disabling tests that fail with SVN 1.7"
disabled="${disabled} ${test_svn}"
# Reset all previously disabled tests
cd "${S}/t"
for i in *.sh.DISABLED ; do
[[ -f "${i}" ]] && mv -f "${i}" "${i%.DISABLED}"
done
einfo "Disabled tests:"
for i in ${disabled} ; do
[[ -f "${i}" ]] && mv -f "${i}" "${i}.DISABLED" && einfo "Disabled $i"
done
# Avoid the test system removing the results because we want them ourselves
sed -e '/^[[:space:]]*$(MAKE) clean/s,^,#,g' \
-i "${S}"/t/Makefile
# Clean old results first, must always run
cd "${S}/t"
nonfatal git_emake clean
# Now run the tests, keep going if we hit an error, and don't terminate on
# failure
cd "${S}"
einfo "Start test run"
#MAKEOPTS=-j1
nonfatal git_emake --keep-going test
rc=$?
# Display nice results, now print the results
cd "${S}/t"
nonfatal git_emake aggregate-results
# And bail if there was a problem
[ $rc -eq 0 ] || die "tests failed. Please file a bug."
}
showpkgdeps() {
local pkg=$1
shift
elog " $(printf "%-17s:" ${pkg}) ${@}"
}
pkg_postinst() {
use emacs && elisp-site-regen
use python && python_mod_optimize git_remote_helpers
einfo "Please read /usr/share/bash-completion/git for Git bash command
completion"
einfo "Please read /usr/share/bash-completion/git-prompt for Git bash prompt"
einfo "Note that the prompt bash code is now in the seperate script"
elog "These additional scripts need some dependencies:"
echo
showpkgdeps git-quiltimport "dev-util/quilt"
showpkgdeps git-instaweb \
"|| ( www-servers/lighttpd www-servers/apache )"
echo
}
pkg_postrm() {
use emacs && elisp-site-regen
use python && python_mod_cleanup git_remote_helpers
}